import { Lens, Handler, TransformConfig, KeyedLens } from "../internal";
export declare abstract class BaseLens<T = any> implements Lens<T> {
    readonly selectorCache: Map<any, BaseLens<any>>;
    readonly derivations: BaseLens[];
    readonly parents: BaseLens[];
    changedDerivations?: BaseLens[];
    lensId: number;
    dirty: number;
    changedParents: number;
    state?: T;
    hot: boolean;
    computed: boolean;
    propagateChanged(): void;
    propagateReady(changed: boolean): void;
    value(): T;
    subscribe(handler: Handler<T>): any;
    registerDerivation(lens: BaseLens): void;
    removeDerivation(lens: BaseLens): void;
    do(...things: any[]): any;
    toString(): string;
    transform<R>(config: Partial<TransformConfig<T, R>>): Lens<R>;
    select(...args: any[]): KeyedLens<any>;
    abstract recompute(): T;
    abstract resume(): void;
    abstract suspend(): void;
    abstract update(producer: ((draft: T) => void)): void;
    abstract getCacheKey(): any;
    abstract describe(): string;
}
