import { BaseLens, Lens, Updater, Producer } from "../internal";
export interface TransformConfig<T, R> {
    description: string;
    cacheKey: any;
    onNext(newBaseValue: T, currentValue: R | undefined, self: Lens<R>): R;
    onUpdate(updater: Producer<R>, next: (updater: Producer<T>) => void, self: Lens<R>): void;
    onSuspend(): void;
    onResume(): void;
}
export declare class Pipe<T, R> extends BaseLens<R> {
    private base;
    config: TransformConfig<T, R>;
    constructor(base: Lens<T>, config: Partial<TransformConfig<T, R>>);
    recompute(): any;
    update(updater: ((draft: any) => void)): void;
    nextUpdate: (updater: Updater<T>) => void;
    getCacheKey(): any;
    resume(): void;
    suspend(): void;
    describe(): string;
}
