import { BaseLens, Lens } from "../internal";
export declare class Merge<X = any, T extends ReadonlyArray<X> = any[]> extends BaseLens<T> {
    bases: BaseLens[];
    constructor(bases: BaseLens[]);
    recompute(): any;
    update(updater: ((draft: T) => T | void)): void;
    resume(): void;
    suspend(): void;
    getCacheKey(): undefined;
    describe(): string;
}
export declare function merge<A>(lens0: Lens<A>): Lens<[A]>;
export declare function merge<A, B>(lens0: Lens<A>, lens: Lens<B>): Lens<[A, B]>;
export declare function merge<A, B, C>(lens0: Lens<A>, lens1: Lens<B>, lens2: Lens<C>): Lens<[A, B, C]>;
export declare function merge<A, B, C, D>(lens0: Lens<A>, lens1: Lens<B>, lens2: Lens<C>, lens3: Lens<D>): Lens<[A, B, C, D]>;
export declare function merge<A, B, C, D, E>(lens0: Lens<A>, lens1: Lens<B>, lens2: Lens<C>, lens3: Lens<D>, lens4: Lens<E>): Lens<[A, B, C, D, E]>;
export declare function merge<A, B, C, D, E, F>(lens0: Lens<A>, lens1: Lens<B>, lens2: Lens<C>, lens3: Lens<D>, lens4: Lens<E>, lens5: Lens<F>): Lens<[A, B, C, D, E, F]>;
export declare function merge(...lenses: Lens[]): Lens<any>;
