import { Lens } from "../internal";
export declare type KeyValueMap<T> = {
    [key: string]: T;
};
export declare const emptyArray: never[];
export declare function noop(): void;
export declare function fail(msg: string): never;
export declare function grabValue<T>(lens: Lens<T>): T;
export declare function _shallowEqual(ar1: any, ar2: any): boolean;
export declare type DiffResult<T> = {
    changed: [string, T, T][];
    added: [string, T][];
    removed: [string, T][];
};
export declare function shallowDiff<T>(baseValue: T[], newValue: T[]): DiffResult<T>;
export declare function shallowDiff<T>(baseValue: KeyValueMap<T>, newValue: KeyValueMap<T>): DiffResult<T>;
export declare function each<A>(value: A[] | KeyValueMap<A>, cb: (value: A, index: string | number) => void): void;
export declare function once(fn: () => void): () => void;
export declare function isFn(thing: any): thing is Function;
export declare function isArray(thing: any): thing is any[];
export declare function isObject(thing: any): boolean;
export declare function stringifyFunction(fn: Function): string;
export declare function trim(str: string): string;
