import {Lens, Handler} from "../internal"
export abstract class BaseLens<T = any> implements Lens<T> {
    readonly selectorCache: Map<any, BaseLens<any>>
    readonly subscriptions: Handler<T>[]
    readonly derivations: BaseLens[]
    readonly parents: BaseLens[]
    changedDerivations?: BaseLens[]
    lensId: number
    dirty: number
    changedParents: number
    state?: T
    propagateChanged(): void
    propagateReady(changed: boolean): void
    protected readonly hot: number
    value(): T
    subscribe(handler: Handler<T>): () => void
    registerDerivation(lens: BaseLens): void
    removeDerivation(lens: BaseLens): void
    view(...things: any[]): any
    toString(): string
    abstract recompute(): T
    abstract resume(): void
    abstract suspend(): void
    abstract update(producer: ((draft: T) => void)): void
    abstract getCacheKey(): any
    abstract describe(): string
}
export declare function isLens(thing: any): thing is Lens
