import {Pipe, Updater, Lens} from "../internal"
export declare class Recorder<T> extends Pipe implements Lens<T> {
    private readonly recordedUpdates
    private recording
    update(updater: Updater<T>): void
    pause(): void
    resume(): void
    reset(): void
    /**
     * Replays the recorded update onto the target
     * This process is atomic; if one of the updaters throws an exception,
     * the target will be unmodified
     */
    replay(target: Lens<T>): void
    getCacheKey(): undefined
    describe(): string
}
