import { Lens, Transformer } from "../internal";
import { KeyValueMap } from "../core/utils";
export declare type MapReduceChanges<U> = {
    added: [string, U][];
    removed: [string, U][];
    updated: [string, U, U][];
};
export declare function mapReduce<T, U, S extends T[] | KeyValueMap<T>, R>(mapper: (lens: Lens<T>, key: string) => Lens<U>, reducer: (previousValue: R, changes: MapReduceChanges<U>, sourceValue: S) => R): Transformer<S, Lens<R>>;
